####BAMM for ERICACEAE meta peer review oct 2019

library(BAMMtools)
library(geiger)
library(ape)
tree <- read.tree("Ericaceae.May.tree")
tree



plot(tree, edge.width = 2)
Ntip(tree)
#349

setBAMMpriors(read.tree("Ericaceae.May.tree")

edata <- getEventData(tree, eventdata = "ERICA.event_data.txt", burnin=0.2)
shift_probs <- summary(edata)

#Rate through time
plotRateThroughTime(edata, ratetype="speciation")
plotRateThroughTime(edata, ratetype="extinction")


plot(tree)

##Refer to Bamm tutorial 2015 Phyloseminar
plot.bammdata(edata, legend=T, spex='netdiv')

##did the MCMC runs converge?

mcmcout <- read.csv("ERICA.mcmc_out.txt")
plot(mcmcout$logLik ~ mcmcout$generation)

#discard the first 10% of samples as burnin:
burnstart <- floor(0.1 * nrow(mcmcout))
postburn <- mcmcout[burnstart:nrow(mcmcout), ]

#it is good to check the effective sample sizes of the log-likelihood and the number of shift events present in each sample. 
#We’ll do this using the coda library for R:
library(coda)
effectiveSize(postburn$N_shifts)
effectiveSize(postburn$logLik)
#In general, we want these to be at least 200 (and 200 is on the low side, but might be reasonable for very large datasets).


###
tr <- ladderize(tree)
axisPhylo(side = 1, root.time = NULL, backward = TRUE)


###
edata <- getEventData(tr, eventdata = "C:/Users/andrew.thornhill/Documents/Andrew/Manuscripts/Angophora and Corymbia/BAMM_2012/event_data.txt", burnin=0.5)
summary(edata)

plot.bammdata(edata, lwd=1, legend=T)
axis(1, at=max(branching.times(tree))-0:80, labels=0:80)
css <- credibleShiftSet(edata, expectedNumberOfShifts=1, threshold=5, set.limit = 0.95)
css$number.distinct
summary(css)
plot.credibleshiftset(css)
